## EDBusSource EDBusSource |

## Functions

const gchar * | e_dbus_source_get_uid ()
gchar * | e_dbus_source_dup_uid ()
void | e_dbus_source_set_uid ()
const gchar * | e_dbus_source_get_data ()
gchar * | e_dbus_source_dup_data ()
void | e_dbus_source_set_data ()
gboolean | e_dbus_source_call_allow_auth_prompt_sync ()
void | e_dbus_source_call_allow_auth_prompt ()
gboolean | e_dbus_source_call_allow_auth_prompt_finish ()
void | e_dbus_source_complete_allow_auth_prompt ()
GDBusInterfaceInfo * | e_dbus_source_interface_info ()
guint | e_dbus_source_override_properties ()
EDBusSource * | e_dbus_source_proxy_new_sync ()
void | e_dbus_source_proxy_new ()
EDBusSource * | e_dbus_source_proxy_new_finish ()
EDBusSource * | e_dbus_source_proxy_new_for_bus_sync ()
void | e_dbus_source_proxy_new_for_bus ()
EDBusSource * | e_dbus_source_proxy_new_for_bus_finish ()
EDBusSource * | e_dbus_source_skeleton_new ()

## Properties

gchar * | data | Read / Write
gchar * | uid | Read / Write

## Signals

gboolean | handle-allow-auth-prompt | Run Last

## Types and Values

| EDBusSource
struct | EDBusSourceProxy
struct | EDBusSourceSkeleton

## Object Hierarchy

        GInterface
        ╰── EDBusSource
        GObject
        ├── GDBusInterfaceSkeleton
        │   ╰── EDBusSourceSkeleton
        ╰── GDBusProxy
            ╰── EDBusSourceProxy

## Prerequisites

EDBusSource requires GObject.

## Implemented Interfaces

EDBusSourceProxy implements GDBusInterface, GInitable, GAsyncInitable and EDBusSource.

EDBusSourceSkeleton implements GDBusInterface and EDBusSource.

## Known Implementations

EDBusSource is implemented by EDBusSourceProxy and EDBusSourceSkeleton.

## Description

## Functions

### e_dbus_source_get_uid ()

    const gchar *
    e_dbus_source_get_uid (EDBusSource *object);

Gets the value of the "UID" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `e_dbus_source_dup_uid()` if on another thread.

#### Parameters

object | A EDBusSource. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none]

### e_dbus_source_dup_uid ()

    gchar *
    e_dbus_source_dup_uid (EDBusSource *object);

Gets a copy of the "UID" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

#### Parameters

object | A EDBusSource. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full]

### e_dbus_source_set_uid ()

    void
    e_dbus_source_set_uid (EDBusSource *object,
                           const gchar *value);

Sets the "UID" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

#### Parameters

object | A EDBusSource. |
value | The value to set. |

### e_dbus_source_get_data ()

    const gchar *
    e_dbus_source_get_data (EDBusSource *object);

Gets the value of the "Data" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `e_dbus_source_dup_data()` if on another thread.

#### Parameters

object | A EDBusSource. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none]

### e_dbus_source_dup_data ()

    gchar *
    e_dbus_source_dup_data (EDBusSource *object);

Gets a copy of the "Data" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

#### Parameters

object | A EDBusSource. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full]

### e_dbus_source_set_data ()

    void
    e_dbus_source_set_data (EDBusSource *object,
                            const gchar *value);

Sets the "Data" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

#### Parameters

object | A EDBusSource. |
value | The value to set. |

### e_dbus_source_call_allow_auth_prompt_sync ()

    gboolean
    e_dbus_source_call_allow_auth_prompt_sync
                                   (EDBusSource *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `AllowAuthPrompt()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_source_call_allow_auth_prompt()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusSourceProxy. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

### e_dbus_source_call_allow_auth_prompt ()

    void
    e_dbus_source_call_allow_auth_prompt (EDBusSource *proxy,
                                          GCancellable *cancellable,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data);

Asynchronously invokes the `AllowAuthPrompt()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_source_call_allow_auth_prompt_finish()` to get the result of the operation.

See `e_dbus_source_call_allow_auth_prompt_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusSourceProxy. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### e_dbus_source_call_allow_auth_prompt_finish ()

    gboolean
    e_dbus_source_call_allow_auth_prompt_finish
                                   (EDBusSource *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_source_call_allow_auth_prompt()`.

#### Parameters

proxy | A EDBusSourceProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_source_call_allow_auth_prompt()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

### e_dbus_source_complete_allow_auth_prompt ()

    void
    e_dbus_source_complete_allow_auth_prompt
                                   (EDBusSource *object,
                                    GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `AllowAuthPrompt()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusSource. |
invocation | A GDBusMethodInvocation. | [transfer full]

### e_dbus_source_interface_info ()

    GDBusInterfaceInfo *
    e_dbus_source_interface_info (void);

Gets a machine-readable description of the org.gnome.evolution.dataserver.Source D-Bus interface.

#### Returns

A GDBusInterfaceInfo. Do not free.

[transfer none]

### e_dbus_source_override_properties ()

    guint
    e_dbus_source_override_properties (GObjectClass *klass,
                                       guint property_id_begin);

Overrides all GObject properties in the EDBusSource interface for a concrete class. The properties are overridden in the order they are defined.

#### Parameters

klass | The class structure for a GObject-derived class. |
property_id_begin | The property id to assign to the first overridden property. |

#### Returns

The last property id.

### e_dbus_source_proxy_new_sync ()

    EDBusSource *
    e_dbus_source_proxy_new_sync (GDBusConnection *connection,
                                  GDBusProxyFlags flags,
                                  const gchar *name,
                                  const gchar *object_path,
                                  GCancellable *cancellable,
                                  GError **error);

Synchronously creates a proxy for the D-Bus interface org.gnome.evolution.dataserver.Source. See `g_dbus_proxy_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `e_dbus_source_proxy_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [allow-none]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusSourceProxy]

### e_dbus_source_proxy_new ()

    void
    e_dbus_source_proxy_new (GDBusConnection *connection,
                             GDBusProxyFlags flags,
                             const gchar *name,
                             const gchar *object_path,
                             GCancellable *cancellable,
                             GAsyncReadyCallback callback,
                             gpointer user_data);

Asynchronously creates a proxy for the D-Bus interface org.gnome.evolution.dataserver.Source. See `g_dbus_proxy_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_source_proxy_new_finish()` to get the result of the operation.

See `e_dbus_source_proxy_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [allow-none]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### e_dbus_source_proxy_new_finish ()

    EDBusSource *
    e_dbus_source_proxy_new_finish (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_source_proxy_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_source_proxy_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusSourceProxy]

### e_dbus_source_proxy_new_for_bus_sync ()

    EDBusSource *
    e_dbus_source_proxy_new_for_bus_sync (GBusType bus_type,
                                          GDBusProxyFlags flags,
                                          const gchar *name,
                                          const gchar *object_path,
                                          GCancellable *cancellable,
                                          GError **error);

Like `e_dbus_source_proxy_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `e_dbus_source_proxy_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusSourceProxy]

### e_dbus_source_proxy_new_for_bus ()

    void
    e_dbus_source_proxy_new_for_bus (GBusType bus_type,
                                     GDBusProxyFlags flags,
                                     const gchar *name,
                                     const gchar *object_path,
                                     GCancellable *cancellable,
                                     GAsyncReadyCallback callback,
                                     gpointer user_data);

Like `e_dbus_source_proxy_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_source_proxy_new_for_bus_finish()` to get the result of the operation.

See `e_dbus_source_proxy_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### e_dbus_source_proxy_new_for_bus_finish ()

    EDBusSource *
    e_dbus_source_proxy_new_for_bus_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_source_proxy_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_source_proxy_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusSourceProxy]

### e_dbus_source_skeleton_new ()

    EDBusSource *
    e_dbus_source_skeleton_new (void);

Creates a skeleton object for the D-Bus interface org.gnome.evolution.dataserver.Source.

#### Returns

The skeleton object.

[transfer full][type EDBusSourceSkeleton]

## Types and Values

### EDBusSource

    typedef struct _EDBusSource EDBusSource;

Abstract interface type for the D-Bus interface org.gnome.evolution.dataserver.Source.

### struct EDBusSourceProxy

    struct EDBusSourceProxy;

The EDBusSourceProxy structure contains only private data and should only be accessed using the provided API.

### struct EDBusSourceSkeleton

    struct EDBusSourceSkeleton;

The EDBusSourceSkeleton structure contains only private data and should only be accessed using the provided API.

## Property Details

### The `“data”` property

      “data”                     gchar *

Represents the D-Bus property "Data".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Default value: NULL

### The `“uid”` property

      “uid”                      gchar *

Represents the D-Bus property "UID".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Default value: NULL

## Signal Details

### The `“handle-allow-auth-prompt”` signal

    gboolean
    user_function (EDBusSource           *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `AllowAuthPrompt()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_source_complete_allow_auth_prompt()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusSource. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last